#/* Copyright 1998-2011 Research Foundation State University of New York */
#
#/* This file is part of QuB.                                            */
#
#/* QuB is free software; you can redistribute it and/or modify          */
#/* it under the terms of the GNU General Public License as published by */
#/* the Free Software Foundation, either version 3 of the License, or    */
#/* (at your option) any later version.                                  */
#
#/* QuB is distributed in the hope that it will be useful,               */
#/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
#/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
#/* GNU General Public License for more details.                         */
#
#/* You should have received a copy of the GNU General Public License,   */
#/* named LICENSE.txt, in the QuB program directory.  If not, see        */
#/* <http://www.gnu.org/licenses/>.                                      */

import os
import os.path
import re
import string
import qubtree
import QUB
from Buttons import *
from Dialogs import *


def float_or_zero(x):
    if x:
        return float(x)
    return 0.0        

def TableResult(props):
    path = props['path']
    try:
        fi = open(path)
        rows = []
        for line in fi:
            rows.append( [x.strip() for x in re.split('\t', line)] )
        nums = []
        try:
            nums.append( map(float, rows[0]) )
            labels = map(lambda i: "col%d"%(i+1), xrange(len(rows[0])))
            rows = rows[1:]
        except:
            nums.append( map(float_or_zero, rows[1]) )
            labels = rows[0]
            rows = rows[2:]
        for row in rows:
            if row:
                nums.append( map(float_or_zero, row) )

        result = qubtree.Node('Result')
        result['ResultType'].data = 'TbRs'
        result['FileName'].data = path
        ds = result['DataSet']
        for segi, row in enumerate(nums):
            seg = ds.append('Segment')
            seg.data = (segi, segi)
            seg['Index'].data = segi
            for vari, lbl in enumerate(labels):
                if vari < len(row):
                    seg[lbl].data = row[vari]
        QUB.ResultsView.addResults(result)
    except Exception, e:
        QUB.Report(e)
            

AddTaskButton('TbRes', TableResult, 'TbRs', 1, 1,
                      'Convert a tab-separated text file to Results', '',
                      'TableResult properties:',
                      [DialogText("path", "text file:", "C:\\", acceptString)],
                      'Scripts')
